#ifndef HTTP_SERVER
#define HTTP_SERVER

#include "mbed.h"
#include "SNIC_WifiInterface.h"
#include "TCPSocketServer.h"
#include "TCPSocketConnection.h"

#define HTTP_REPLY_MAX_STRING 1024

enum
{
    HTTP_200_OK         = 200,
    HTTP_400_BADREQUEST = 400,
    HTTP_404_NOTFOUND   = 404
};


class HTTPServer
{
    public :
        HTTPServer();
        virtual ~HTTPServer();
        bool init(int port);
        void run();
        
    private :
        void handle_request(char* buffer);
        void create_response(char* buffer);
        TCPSocketServer socketserver;
        char reply[HTTP_REPLY_MAX_STRING];
        int response_code;
};

#endif

